<%@ Page Language="c#" Inherits="ClientSelectColumn.DefaultCS" CodeFile="DisallowOtherSelection.aspx.cs" %>

<%@ Register TagPrefix="radG" Namespace="Telerik.WebControls" Assembly="RadGrid.Net2" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title>ClientSideSelectColumn -- Dissalow other (de)selection</title>
</head>
<body class="BODY">
    <form runat="server" id="mainForm" method="post" style="width: 100%;">
         <script type="text/javascript"> 
            var currentClickEvent = null;

            function GridCreated()
            {
                var grid = this;
                
                //non-ie click event capture
                //the event handler will get fired *before* the row click event 
                //and we use that to cache the current event object
                if (grid.Control.addEventListener)
				    grid.Control.addEventListener("click", GridTableClick, true);
            }

            function GridTableClick(e)
            {
			    currentClickEvent = e;
            }
            
            //IE has a global event object. We get the previously cached event object for other browsers
            function GetClickEvent()
            {
                return window.event || currentClickEvent;
            }
            
            //cancel all select/deselect operation triggered by non-checkbox row clicks
            function CancelNonInputSelect(row) 
            { 
                var e = GetClickEvent();
                //IE - srcElement, Others - target
                var targetElement = e.srcElement || e.target;

                //is the clicked element an input checkbox? <input type="checkbox"...>
                if(targetElement.tagName.toLowerCase() != "input" &&
                    targetElement.type.toLowerCase() != "checkbox")
                {
                    //cancel the event
                    return false;
                }
                
                //clean up after all (de)selections are performed
                window.setTimeout(function() {
                    currentClickEvent = null;
                   }, 0);
            } 
          </script>         
          
          
        <radG:RadGrid ID="RadGrid1" DataSourceID="AccessDataSource1" AllowMultiRowSelection="true"
            runat="server" AllowSorting="True" GridLines="None" Width="95%">
            <MasterTableView Width="100%">
                <Columns>
                    <radG:GridClientSelectColumn UniqueName="ClientSelectColumn" />
                </Columns>
            </MasterTableView>
            <ClientSettings>
                <Selecting AllowRowSelect="true"></Selecting>
                <ClientEvents OnGridCreated="GridCreated" OnRowSelecting="CancelNonInputSelect" OnRowDeselecting="CancelNonInputSelect" />
            </ClientSettings>
        </radG:RadGrid>
        
        <asp:AccessDataSource ID="AccessDataSource1" DataFile="~/App_Data/Nwind.mdb"
            SelectCommand="SELECT TOP 10 CustomerID, CompanyName, ContactName, ContactTitle, Address, PostalCode FROM Customers"
            runat="server"></asp:AccessDataSource>
        
    </form>
</body>
</html>
